//
// Copyright(C) Rick Blommers 1999
// Written by Rick Blommers <rick@brainwave.demon.nl>
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DBSMSQUERY_H__5AE4C2C4_09D2_11D3_83FF_0008C73BB59A__INCLUDED_)
#define AFX_DBSMSQUERY_H__5AE4C2C4_09D2_11D3_83FF_0008C73BB59A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <ddeml.h>			// Should be in stdafx

class CMSQuery
{
  // Members
	DWORD m_idInst;					// The dde handle
	HCONV m_hConv;					// The conversation handle
	HCONV m_hQry;					// The conversation with the query window

	HSZ m_hszServName;				// service name string handle 
	HSZ m_hszSysTopic;				// System topic string handle 
	HSZ m_hszQryTopic;				// Query topic string handle

	HANDLE m_hProcess;				// Did we create the query process ?? Yes, then we terminate it

	CString m_sqlstatement;			// The sql-statement
	CString m_connection;			// The connection string
	BOOL m_qryOK;					// Is the query (and the connection string) ok

	DWORD m_TransActionID;			// The transaction ID for the active asynchrone transaction
	CDialog *m_dlg;

  // Constants (enums)
	enum{
		_execDelay		= 10000,		// wait 10 seconds
		_startupDelay	= 60000			// wait 1 minute   
	};


  // Construction / destruction / initialisation
	public:
	CMSQuery();						// Construction
	~CMSQuery();					// Destruction

  // The communication routines (with the parent)
	BOOL Create(CString & text,CString & connect, CDialog *pDlg);	// Creates a session with MSQuery
	BOOL QueryOK() {return m_qryOK; }					// Was the MS-Query communication successfull
	CString & GetQuery() {return m_sqlstatement; }		// returns the query
	CString & GetConnection() { return m_connection;}	// returns the connection string

  // The MSQuery commands (easy like in Visual Basic)
	protected:
	BOOL Execute(HCONV hConv, CString command, int delay=_execDelay, LPDWORD res=NULL );
	BOOL Request(HCONV hConv, const char *lpszItemname, CString & result, int delay=_execDelay);

  // The callback routine (must be static)
	protected:
	static HDDEDATA CALLBACK DdeCallback(UINT uType,UINT  uFmt, HCONV hconv, HSZ hsz1, HSZ hsz2, HDDEDATA hdata, DWORD dwData1, DWORD dwData2);


};

#endif // !defined(AFX_DBSMSQUERY_H__5AE4C2C4_09D2_11D3_83FF_0008C73BB59A__INCLUDED_)
